package view;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import javax.swing.*;
import javax.swing.event.*;

import UdpServer.UdpServer;

@SuppressWarnings("serial")
public class FirstPanel extends JPanel implements ActionListener{
	/**
	 * @author Giovanni Romio, Battistini Luca
	 */
	
	/*Main Frame to switch for sessions*/
	private JFrame mainFrame;
	/* Panel Dimensions */
	private static final int WIDTH = 640;
	private static final int HEIGHT = 350;
	/* JTextField dimensions*/
	private static final int TXTWIDTH = 200;
	private static final int TXTHEIGHT = 20;
	/*Components*/
	private JLabel lblDevices;
	private JLabel lblIpAdress;
	private JTextField txtDevices;
	private JButton btnContinue;
	private JRadioButton rdbManual;
	private JRadioButton rdbRemote;
	/*UdpServer*/
	UdpServer udpServer;
	Thread myServer;
	
	/**
	 * Initialize connection between UdpServer and Bomb UdpClient
	 * @throws IOException 
	 */
	public FirstPanel() throws IOException{
		super();
	
		/*Starting UdpServer*/
		udpServer = UdpServer.getIstance();
		myServer = new Thread(udpServer);
		myServer.start();
		
		/*Size of the Panel*/
		this.setSize(new Dimension(WIDTH, HEIGHT));
		this.setPreferredSize(new Dimension(WIDTH, HEIGHT));
		
		lblDevices = new JLabel("Device connected:");
		lblDevices.setBounds(
				(int) (this.getWidth()/2 - lblDevices.getPreferredSize().getWidth()/2),
				(int) (this.getHeight()*0.2),
				(int)lblDevices.getPreferredSize().getWidth(),
				(int)lblDevices.getPreferredSize().getHeight()
				);
		
		txtDevices = new JTextField();
		txtDevices.setBounds(
				(int) (this.getWidth()/2 - TXTWIDTH/2),
				(int) (this.getHeight()*0.3),
				TXTWIDTH,
				TXTHEIGHT
				);
		/*Enable continue Button if connection between pc and arduino is estabilished*/
		txtDevices.getDocument().addDocumentListener(new DocumentListener() {
			
			@Override
			public void removeUpdate(DocumentEvent e) {
				
			}
			
			@Override
			public void insertUpdate(DocumentEvent e) {
				btnContinue.setEnabled(true);				
			}
			
			@Override
			public void changedUpdate(DocumentEvent e) {
								
			}
		});
		
		btnContinue = new JButton("Continue");
		btnContinue.setBounds(
				(int) (this.getWidth()/2 - btnContinue.getPreferredSize().getWidth()/2),
				(int) (this.getHeight()*0.4),
				(int)btnContinue.getPreferredSize().getWidth(),
				(int)btnContinue.getPreferredSize().getHeight()
				);
		btnContinue.setEnabled(false);
		btnContinue.addActionListener(this);
		
		rdbManual = new JRadioButton("Manual");
		rdbManual.setBounds(
				(int)(this.getWidth()/2 - rdbManual.getPreferredSize().getWidth()),
				(int)(this.getHeight()*0.5),
				(int)rdbManual.getPreferredSize().getWidth(),
				(int)rdbManual.getPreferredSize().getHeight()
				);
		rdbRemote = new JRadioButton("Remote");
		rdbRemote.setBounds((int)(this.getWidth()/2),
				(int)(this.getHeight()*0.5),
				(int)rdbRemote.getPreferredSize().getWidth(),
				(int)rdbRemote.getPreferredSize().getHeight()
				);
		/*Allow only 1 radio button avaible at one time*/
		ButtonGroup radio = new ButtonGroup();
		radio.add(rdbManual);
		radio.add(rdbRemote);
		
		lblIpAdress = new JLabel(udpServer.getIpAdress().toString() + "(" + udpServer.getPort() +")");
		lblIpAdress.setBounds(
				(int) (this.getWidth() - lblIpAdress.getPreferredSize().getWidth()),
				(int) (this.getHeight()*0.9),
				(int)lblIpAdress.getPreferredSize().getWidth(),
				(int)lblIpAdress.getPreferredSize().getHeight()
				);	
		
	//	udpServer.showAddress(txtDevices);
		this.setLayout(null);
		this.add(lblDevices);
		this.add(txtDevices);
		this.add(btnContinue);
		this.add(rdbManual);
		this.add(rdbRemote);
		this.add(lblIpAdress);
		
	}
	/**
	 * @param e, after Button is pressed change visible layout
	 * THIS CODE MUST BE IMPLEMENTED BY THE CONTROLLER
	 */
	
	public void actionPerformed(ActionEvent e) {
		/*
		this.setVisible(false);
		try {
			if(rdbManual.isSelected()){
				
				mainFrame.setContentPane(new ThirdPanel());
			}
			if(rdbRemote.isSelected()){
				
				mainFrame.setContentPane(new SecondPanel(mainFrame));
			}			
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		*/
	}
	
	
	public void setTxtDevices(String message){
		this.txtDevices.setText(message);
	}
	
}
