package controller;

import java.io.IOException;

import javax.swing.JFrame;

import udpServer.UdpServer;
import view.FirstPanel;
import view.SecondPanel;

public class FirstController implements Runnable {
	/**
	 * @author Giovanni Romio, Battistini Luca
	 * 
	 * First Controller must handle:
	 * - txtBox of FirstPanel
	 * - lblIp of FirstPanel
	 * - btnContinue of FirstPanel 
	 * 
	 * */
	
	private FirstPanel p1;
	private UdpServer udpServer;
	private String arduinoIp;
	private boolean running = true;
	private JFrame mainFrame;
	private FirstPanelObserver observer;
	
	public FirstController(FirstPanel p1) throws IOException{
		this.p1 = p1;
		mainFrame = p1.getMainFrame();
		/*Get the istance of the udpServer*/
		udpServer = UdpServer.getIstance();
		/*Show the Ip of the UdpServer*/
		this.p1.setIp(udpServer.getAddress());
	}

	/**
	 * Loop until connection get estabilished
	 */
	public void run() {		
		while(running){
			/*Set the ip for the device connected*/
			if(udpServer.getDeviceConnected() != null){
				arduinoIp = udpServer.getDeviceConnected().toString();
				observer.setIp(arduinoIp);
				this.running = false;
			}			

		}		
		
	}
	
	public void nextSession() throws IOException{
		mainFrame.setContentPane(new SecondPanel(mainFrame));
	}
	
	public void attachObserver(FirstPanelObserver observer){
		this.observer = observer;
	}
	
	public interface FirstPanelObserver{
		
		void setIp(String ip);
		
	}

	
}
