package view;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.*;
import javax.swing.border.Border;

import controller.SecondController;
import udpServer.UdpServer;


@SuppressWarnings("serial")
public class SecondPanel extends JPanel{
	/**
	 * 
	 * @author Giovanni Romio, Battistini Luca
	 */
	
	/*Main Frame to switch for sessions*/
	JFrame mainFrame;
	/* Panel Dimensions */
	private static final int WIDTH = 640;
	private static final int HEIGHT = 400;
	/* JTextField dimensions*/
	private static final int TXTWIDTH = 230;
	private static final int TXTHEIGHT = 20;
	/*TextArea Dimension*/
	private static final int TXTAREAWIDTH = 300;
	private static final int TEXTAREAHEIGHT = 300;
	/* SubPanels*/
	private JPanel leftPanel;
	private JPanel rightPanel;
	/* Components of the Frame*/
	private JLabel arduinoIp;
	private JLabel pcIp;
	private JTextField txtPcMessage;
	private JTextArea arduinoLog;
	private JTextArea pcLog;
	private JButton btnSend;
	/*UdpServer*/
	UdpServer myServer;
	/*Controller for this session*/
	SecondController c2;
	
	public SecondPanel(JFrame mainFrame) throws IOException{
		super();
		
		/*Get the UdpServer*/
		myServer = UdpServer.getIstance();
		
		/*Main Frame*/
		this.mainFrame = mainFrame;
		
		/*Size of the Panel*/
		this.setSize(new Dimension(WIDTH, HEIGHT));
		this.setPreferredSize(new Dimension(WIDTH, HEIGHT));
		this.setLayout(new BorderLayout());
		
		/*Initialize subPanels*/
		leftPanel = new JPanel();
		leftPanel.setLayout(new FlowLayout());
		leftPanel.setPreferredSize(new Dimension(WIDTH/2, HEIGHT));
		rightPanel = new JPanel();
		rightPanel.setLayout(new FlowLayout());
		rightPanel.setPreferredSize(new Dimension(WIDTH/2, HEIGHT));
		
		/*Border of the JText area*/
		Border border = BorderFactory.createLineBorder(Color.BLACK);
		
		/*Labels containing ip address of Arduino and pc*/
		arduinoIp = new JLabel("arduino Ip:");
		pcIp = new JLabel("pc Ip:");
		
		/*Text area containing messages received from Arduino*/
		arduinoLog = new JTextArea("Hello carambideeeeee");
		arduinoLog.setPreferredSize(new Dimension(TXTAREAWIDTH, TEXTAREAHEIGHT));
		arduinoLog.setBorder(BorderFactory.createCompoundBorder(border, 
	           BorderFactory.createEmptyBorder(10, 10, 10, 10)));
		
		pcLog = new JTextArea("hello");
		pcLog.setPreferredSize(new Dimension(TXTAREAWIDTH, TEXTAREAHEIGHT));
		pcLog.setBorder(BorderFactory.createCompoundBorder(border, 
	            BorderFactory.createEmptyBorder(10, 10, 10, 10)));
		
		/*Text field to enter the message to send to Arduino*/
		txtPcMessage = new JTextField();
		txtPcMessage.setPreferredSize(new Dimension(TXTWIDTH, TXTHEIGHT));
		
		/*Button to send message to Arduino via Udp connection*/
		btnSend = new JButton("Send");
		btnSend.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent arg0) {
				try {
					c2.sendMessage(txtPcMessage.getText());
				} catch (IOException e) {
					e.printStackTrace();
				}
				
			}
		});
		
		leftPanel.add(arduinoIp);
		leftPanel.add(arduinoLog);
		
		rightPanel.add(pcIp);
		rightPanel.add(pcLog);
		rightPanel.add(txtPcMessage);
		rightPanel.add(btnSend);

		this.add(leftPanel, BorderLayout.WEST);
		this.add(rightPanel, BorderLayout.EAST);
		this.setVisible(true);
		
		/*Initialize the controller for this View*/
		c2 = new SecondController(this);
		
	}
}
