package controller;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ControllerManager implements Runnable {

	private List <Controller> controllers;
	private FirstPanelController c1;
	private SecondPanelController c2;
	private ThirdPanelController c3;
	private int currentController = 0;
	private Thread controllerThread;
	private boolean running = true;

	/**
	 * Initialize all the Panel so the switch would be immediate
	 */
	public ControllerManager() {
		controllers = new ArrayList<>();

		c1 = new FirstPanelController();
		controllers.add(c1);

		c2 = new SecondPanelController();
		controllers.add(c2);

		c3 = new ThirdPanelController();
		controllers.add(c3);

		controllerThread = new Thread(this);
		controllerThread.start();
	}

	/**
	 * Update the current view
	 */
	public void run() {
		while(running) {
			try {
				controllers.get(currentController).update();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

	}
	/**
	 * 
	 * @return the current Controller
	 */
	public Controller getCurrentController() {
		return controllers.get(currentController);
	}

	/**
	 * 
	 * @param controller set the controller
	 */
	public void setController(int controller) {
		this.currentController = controller;
		this.controllers.get(currentController).init();
	}


}
