package controller;

public class SecondPanelController extends Controller {

	private PanelObserver observer;
	private String lastMessage;
	private int currentState;
	public static final int CODE = 0;
	public static final int CABLE = 1;
	public static final int TIMER = 2;


	SecondPanelController() { }

	public void init(){
		currentState = CODE;
		lastMessage = myServer.getLastMessage();
	}

	@Override
	public void update() {
		/*wait until panel 2 is ready*/
		if (observer != null) {
			if(lastMessage!= myServer.getLastMessage()) {
				lastMessage = myServer.getLastMessage();
				observer.displayUpdate(lastMessage);
			}
		}

	}

	@Override
	public void attachObserver(PanelObserver observer) {
		this.observer = observer;
	}
	@Override
	public void setBomb(String value){
		/*Control if the input is correct, otherwise refuse the value insert*/
		boolean check = false;
		switch (currentState) {
		case 0:
			check = bomb.setCode(value);
			break;
		case 1:
			check = bomb.setWire(value);
			break;
		case 2:
			check = bomb.setTimer(value);
			break;
		}
		if(check){
			myServer.sendMessage(value);
			currentState ++;
			if(currentState == 3){				
				observer.setNextPanel();
			}
		}else{
			observer.displayUpdate("VALUE INCORRECT");
		}

	}

}

