package view;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import controller.ControllerManager;
import controller.Controller.PanelObserver;


@SuppressWarnings("serial")
public class ThirdPanel extends JPanel implements PanelObserver{
	/**
	 * @author Giovanni Romio, Battisini Luca
	 */
	/* Panel Dimensions */
	private static final int WIDTH = 640;
	private static final int HEIGHT = 370;
	/* JTextField dimensions*/
	private static final int TXTWIDTH = 200;
	private static final int TXTHEIGHT = 20;
	/* JButton dimensions*/
	private static final int BTNWIDTH = 200;
	private static final int BTNHEIGHT = 40;
	/* JLabel dimensions*/
	private static final int LBLWIDTH = 400;
	private static final int LBLHEIGHT = 20;
	/* Components position borders*/
	private static final int PADDINGTOP = 10;
	private static final int PADDINGLEFT = 20;
	/* Number of wires in the bomb*/
	private static final int NUMWIRE = 4;
	/*Components*/
	private JTextField txtTimer;
	private JLabel lblWire1;
	private JLabel lblWire2;
	private JLabel lblWire3;
	private JLabel lblWire4;
	private List <JLabel> lblContainer;
	private JButton btnActivate;
	private JButton btnDefuse;
	/*Controller Manager*/
	private ControllerManager cm;

	public ThirdPanel(ControllerManager controller) {
		super();
		this.cm = controller;
		/*Size of the Panel*/
		this.setSize(new Dimension(WIDTH, HEIGHT));
		this.setPreferredSize(new Dimension(WIDTH, HEIGHT));
		this.setLayout(null);

		txtTimer = new JTextField();
		txtTimer.setBounds(
				(int)(this.getWidth()/2 - TXTWIDTH/2),
				PADDINGTOP,
				TXTWIDTH,
				TXTHEIGHT
				);
		txtTimer.setEditable(false);

		lblWire1 = new JLabel("CABLE 1 :");
		lblWire1.setBounds(
				PADDINGLEFT,
				(int)(this.getHeight()*0.2),
				LBLWIDTH,
				LBLHEIGHT
				);

		lblWire2 = new JLabel("CABLE 2 :");
		lblWire2.setBounds(
				PADDINGLEFT,
				(int)(this.getHeight()*0.3),
				LBLWIDTH,
				LBLHEIGHT
				);

		lblWire3 = new JLabel("CABLE 3 :");
		lblWire3.setBounds(
				PADDINGLEFT,
				(int)(this.getHeight()*0.4),
				LBLWIDTH,
				LBLHEIGHT
				);

		lblWire4 = new JLabel("CABLE 4 :");
		lblWire4.setBounds(
				PADDINGLEFT,
				(int)(this.getHeight()*0.5),
				LBLWIDTH,
				LBLHEIGHT
				);

		lblContainer = new ArrayList<>();
		lblContainer.add(lblWire1);
		lblContainer.add(lblWire2);
		lblContainer.add(lblWire3);
		lblContainer.add(lblWire4);

		btnActivate = new JButton("DETONATE");
		btnActivate.setBounds(
				PADDINGLEFT,
				(int)(this.getHeight()*0.7),
				BTNWIDTH,
				BTNHEIGHT
				);
		
		btnActivate.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				cm.getCurrentController().getServer().sendMessage("DETONATED");
			}
		});
		
		btnDefuse = new JButton("DEFUSE");
		btnDefuse.setBounds(
				PADDINGLEFT + BTNWIDTH ,
				(int)(this.getHeight()*0.7),
				BTNWIDTH,
				BTNHEIGHT
				);
		
		btnDefuse.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				cm.getCurrentController().getServer().sendMessage("DEFUSED");
			}
		});

		this.add(txtTimer);
		this.add(lblWire1);
		this.add(lblWire2);
		this.add(lblWire3);
		this.add(lblWire4);
		this.add(btnActivate);
		this.add(btnDefuse);

		cm.setController(2);
		cm.getCurrentController().attachObserver(this);

	}


	@Override
	public void displayIp(String ip) {	}
	
	/**
	 * @param message "$ccccmm:ss"
	 */
	@Override
	public void displayUpdate(String message) {
		if(message.contains("$")) {
			for(int i = 0; i < NUMWIRE; i++) {
				if(message.charAt(i+1) == '1') {
					lblContainer.get(i).setText("CABLE " + (i+1) + " : CONNECTED");
				} else {
					lblContainer.get(i).setText("CABLE " + (i+1) + " : DISCONNECTED");
				}
				
				txtTimer.setText(message.substring(5));
			}
		} else {
			txtTimer.setText(message);
		}
		
	}
	/**
	 * Not used in this STATE
	 */
	@Override
	public void setNextPanel() { }
	
}
